* NSTRG$ - Name Strings
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0.01, pjw, 2023 Aug 06
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef nstr

        xref lin2flt,fputp

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err



*
nstr
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* qstr$ = NSTR$(adr [, skip%])
*
* where
*       adr   is the location of start of the n-string
*             On return this contains the next address past the string
*       skip% number of prior n-strings to skip (default 0)
*
        move.w sb.gtlin,a2
        jsr (a2)
        bne.s exit

        cmpi.w #2,d3
        beq.s twopar

        subq.w #1,d3
        beq.s onepar

err_bp
        moveq #err.ipar,d0

exit
        rts

onepar
        moveq #0,d3                     d3 = skip num
        moveq #4,d0
        bra.s cont

twopar
        move.l 4(a6,a1.l),d3
        bmi.s err_bp                    cant have negative skip
        moveq #8,d0

cont
        move.l (a6,a1.l),d1
        ble.s err_bp                    cant have negative or zero addr

        add.l d0,sb_arthp(a6)
        moveq #0,d7
        move.l d1,a4

skip
        move.b (a4)+,d7
        move.l a4,d5                    d5 -> start string
        add.l d7,a4                     a4 -> past end string

skipe
        dbra d3,skip

        move.l a4,d6                    d6 = address to return

        moveq #9,d1                     room for str, len (+ odd), addr
        add.w d7,d1
        bclr #0,d1                      d1 = additional room for return string
        move.l d1,d4

        move.w qa.resri,a2
        jsr (a2)

        sub.l d4,sb_arthp(a6)           grab len (+ 2 + 6) b on stack
        move.l sb_arthp(a6),a1
        add.l #8,a1                     string chars goes here

        move.l d5,a4                    a4 -> nstr
        move.w d7,d2                    d2 = nstr length

        bra.s mvbe
mvb
        move.b (a4)+,(a6,a1.l)
        addq.l #1,a1
mvbe
        dbra d2,mvb

        move.l sb_arthp(a6),a1

retstr
        move.l d6,d1                    return address
        bsr lin2flt                     convert to float
        bsr fputp                       stuff addr variable

        addq.l #6,a1
        move.l a1,sb_arthp(a6)
        move.w d7,(a6,a1.l)             set length
        moveq #ar.strng,d4              tell SB string return
        moveq #0,d0                     all ok
        rts
*
        end
