* NSTRCMP%
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef nstrcmp

        xref ut_nstrcmp

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err


*
nstrcmp
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
*       result = NSTRCMP%((X), (Y) [, cmptype%])
*
* where result% can be -1, 0, 1
*       (X) and (Y) are absolute pointers to N-strings in memory
*  and  cmptype% is and optional comparison type code:
*                0 => case sensitive, and 1 => case agnostic (default 1)
*
        move.w sb.gtlin,a2
        jsr (a2)
        bne.s exit

        moveq #1,d0             default = 1
        moveq #8-2,d4           at least two long pars (ret int)

        subq.w #2,d3
        beq.s twopar

        subq.w #1,d3
        bne.s err_bp

        move.l 8(a6,a1.l),d0    only valid values are 0 and <> 0 => 1
        addq.l #4,d4            this much to wipe off stack

twopar
        move.l (a6,a1.l),d2     X
        beq.s err_bp

        move.l 4(a6,a1.l),d1    Y
        beq.s err_bp


        movea.l d2,a0
        movea.l d1,a1
        bsr ut_nstrcmp

        add.l d4,sb_arthp(a6)   leaving room for int return
        movea.l sb_arthp(a6),a1
        move.w d0,(a6,a1.l)
        moveq #ar.int,d4
        moveq #0,d0
        rts

err_bp
        moveq #err.ipar,d0
exit
        rts

*
        end
